/*C program for Bluetooth controlled car demo using 8051*/

#include <reg51.h>

sbit LM1 = P2^0;
sbit LM2 = P2^1;
sbit RM1 = P2^2;
sbit RM2 = P2^3;
sbit Front_light1 = P2^4;
sbit Front_light2 = P2^5;
sbit Back_light1 = P2^6;
sbit Back_light2 = P2^7;

char rx_data, rx_char;

void Serial_init();
void Serial_send(char s);
void Serial_write(unsigned char *p);
char Serial_read(void);
void delay_ms(unsigned int a);

void main()
{
	Serial_init();
	
	LM1 = 0;
	LM2 = 0;
	RM1 = 0;
	RM2 = 0;
	Front_light1 = 1;
	Front_light2 = 1;
	Back_light1 = 1;
	Back_light2 = 1;

	while(1)
	{
		rx_char = Serial_read();

		if(rx_char == 'F')
		{
			LM1 = 1;
			LM2 = 0;
			RM1 = 1;
			RM2 = 0;
		}
		if (rx_char == 'B')
		{
			LM1 = 0;
			LM2 = 1;
			RM1 = 0;
			RM2 = 1;
		}
		if (rx_char == 'L')
		{
			LM1 = 0;
			LM2 = 0;
			RM1 = 1;
			RM2 = 0;
		}
		if (rx_char == 'R')
		{
			LM1 = 1;
			LM2 = 0;
			RM1 = 0;
			RM2 = 0;
		}
		if (rx_char == 'S')
		{
			LM1 = 0;
			LM2 = 0;
			RM1 = 0;
			RM2 = 0;
		}
		if (rx_char == 'W')
		{
			Front_light1 = 0;
			Front_light2 = 0;
			Serial_write("Front lights ON");
		}
		if (rx_char == 'w')
		{
			Front_light1 = 1;
			Front_light2 = 1;
			Serial_write("Front lights OFF");
		}
		if (rx_char == 'U')
		{
			Back_light1 = 0;
			Back_light2 = 0;
			Serial_write("Back lights ON");
		}
		if (rx_char == 'u')
		{
			Back_light1 = 1;
			Back_light2 = 1;
			Serial_write("Back lights OFF");
		}
		delay_ms(20);
	}
}
void Serial_init()
{
	TMOD = 0x20;
	SCON = 0x50;
	TH1 = 0xFD;
	TR1 = 1;
}
void Serial_write(unsigned char *p)
{
	while(*p)
	{
		Serial_send(*p);
		p++;
	}
	Serial_send(0x0A);
}
void Serial_send(char s)
{
	SBUF = s;
	while(TI == 0);
	TI = 0;
}
char Serial_read(void)
{
	while(RI == 0);
	RI = 0;
	rx_data = SBUF;
	return rx_data;
}
void delay_ms(unsigned int a)
{
	unsigned int b,c;

	for (b = 0;b < a;b++)
	{
		for(c = 0;c < 112;c++)
		{
		}
	}
}